include:
  - project: 'p3918/jelastic-ik-deployment'
    ref: main
    file: '/.gitlab-ci-template.yml'

build-test-image:
  stage: build
  tags:
    - docker
  rules:
    - if: $CI_COMMIT_BRANCH
  script:
    - ./ci-build-test-image.sh
    - ./ci-push-test-image.sh

build-production-image:
  stage: build
  tags:
    - docker
  rules:
    - if: $CI_COMMIT_TAG
  script:
    - ./ci-build-prod-image.sh
    - ./ci-push-prod-image.sh

test:
  stage: test
  tags:
    - docker
  script:
    - export MAILER_SERVER=${MAILER_SERVER}
    - export SECRET=${SECRET}
    - ./ci-run-test.sh

deploy:
  stage: deploy
  tags:
    - docker
  rules:
    - if: $CI_COMMIT_TAG && $CI_COMMIT_REF_PROTECTED
  script:
    - docker compose -f docker-compose.yml -f docker-compose.prod.yml up -d flashcards-prod-back

clean:
  stage: clean
  tags:
    - docker
  script:
    - docker container prune -f || true
    - docker volume prune -f || true
    - docker image prune -f || true
    - docker network prune -f || true